Arch Equipment: Difference between revisions

From FreeCAD Documentation
(API and scripting links)
No edit summary
(17 intermediate revisions by 5 users not shown)
Line 3: Line 3:


<!--T:1-->
<!--T:1-->
{{Docnav
|[[Arch_Fence|Fence]]
|[[Arch_CompPipe|CompPipe]]
|[[Arch_Module|Arch]]
|IconL=Arch_Fence.svg
|IconR=Arch_CompPipe.png
|IconC=Workbench_Arch.svg
}}

<!--T:20-->
{{GuiCommand
{{GuiCommand
|Name=Arch Equipment
|Name=Arch Equipment
|MenuLocation=Arch → Equipment
|MenuLocation=Arch → Equipment
|Workbenches=[[Arch Module|Arch]]
|Workbenches=[[Arch_Module|Arch]]
|Shortcut=E Q
|Shortcut={{KEY|E}} {{KEY|Q}}
|SeeAlso=[[Arch_3Views|3 views from mesh]]
|SeeAlso=[[Arch_3Views|Arch 3 views]]
}}
}}


Line 19: Line 29:
[[Image:Arch equipment example.jpg]]
[[Image:Arch equipment example.jpg]]
<translate>
<translate>
<!--T:18-->
{{Caption|Furniture objects enclosed in an [[Arch Equipment|Arch Equipment]] object. The flat projections can be obtained by the [[Draft Shape2DView|Draft Shape2DView]] tool}}


<!--T:13-->
<!--T:13-->
As of version 0.17, equipment objects also have a '''HiRes''' property where a [[Mesh Module|Mesh]] object can be attached. Equipment objects can then be made to display that mesh in the 3D view instead of their shape, which allows to use any high-resolution mesh objects such as detailed pieces of furniture commonly found on websites.
As of version 0.17, equipment objects also have a {{PropertyData|HiRes}} property where a [[Mesh Module|Mesh]] object can be attached. Equipment objects can then be made to display that mesh in the 3D view instead of their shape, which allows to use any high-resolution mesh objects such as detailed pieces of furniture commonly found on websites.


</translate>
</translate>
[[Image:Arch equipment mesh.jpg]]
[[Image:Arch equipment mesh.jpg]]
<translate>
<translate>
<!--T:19-->
{{Caption|Furniture objects enclosed in an [[Arch Equipment|Arch Equipment]] object, with a high resolution mesh attached}}


<!--T:14-->
<!--T:14-->
When using the Arch OBJ exporter, all equipments that are in Mesh display mode will be exported as their mesh instead of their shape.
When using the Arch OBJ exporter, all equipment objects that are in mesh display mode will be exported as their mesh instead of their shape.


==How to use== <!--T:5-->
==Usage== <!--T:5-->


<!--T:6-->
<!--T:6-->
# Select a [[Part Workbench|Part]] shape, and optionally a [[Mesh Workbench|Mesh]] object.
# Select a [[Part Workbench|Part]] shape, and optionally a [[Mesh Workbench|Mesh]] object.
# Press the {{Button|[[Image:Arch Equipment.svg|16px]] [[Arch Equipment]]}} button, or press {{KEY|E}} then {{KEY|Q}} keys.
# Press the {{Button|[[Image:Arch Equipment.svg|16px]] [[Arch Equipment|Arch Equipment]]}} button, or press {{KEY|E}} then {{KEY|Q}} keys.


==Options== <!--T:15-->
==Options== <!--T:15-->
Line 49: Line 63:


==Scripting== <!--T:9-->
==Scripting== <!--T:9-->
{{Emphasis|See also:}} [[Arch API]] and [[FreeCAD Scripting Basics]].
{{Emphasis|See also:}} [[Arch API|Arch API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].


<!--T:10-->
<!--T:10-->
The Equipment tool can be used in [[macros]] and from the [[Python]] console by using the following function:
The Equipment tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
</translate>
</translate>
{{Code|code=
{{Code|code=
Equipment = makeEquipment(baseobj=None, placement=None, name="Equipment")
makeEquipment ( baseObject )
}}
}}
<translate>
<translate>


<!--T:11-->
<!--T:11-->
* Creates an equipment object from a base object (Mesh or Part)
* Creates an {{incode|Equipment}} object from the given {{incode|baseobj}}, which can be a {{incode|Part}} or a {{incode|Mesh}}.
* If a {{incode|placement}} is given, it is used.
* Returns the new equipment object, or None if the operation failed.
* It returns {{incode|None}} if the operation fails.


<!--T:12-->
<!--T:12-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
import Part, Arch
import FreeCAD, Arch

box = Part.makeBox(2,2,2)
base = FreeCAD.ActiveDocument.addObject("Part::Feature","Box")
Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
base.Shape = box
Box.Length = 500
Box.Width = 2000
Arch.makeEquipment(base)
Box.Height = 600

Equip = Arch.makeEquipment(Box)
FreeCAD.ActiveDocument.recompute()
}}
}}
<translate>


<translate>
<!--T:17-->
<!--T:17-->
{{Docnav
{{Arch Tools navi}}
|[[Arch_Fence|Fence]]
{{Userdocnavi}}
|[[Arch_CompPipe|CompPipe]]
|[[Arch_Module|Arch]]
|IconL=Arch_Fence.svg
|IconR=Arch_CompPipe.png
|IconC=Workbench_Arch.svg
}}

</translate>
</translate>
{{Arch Tools navi{{#translation:}}}}

{{Userdocnavi{{#translation:}}}}

Revision as of 14:27, 29 November 2020

Arch Equipment

Menu location
Arch → Equipment
Workbenches
Arch
Default shortcut
E Q
Introduced in version
-
See also
Arch 3 views

Description

The Equipment tool offers you a simple and convenient way to insert non-structural, standalone elements such as pieces of furniture, hidro-sanitary equipments or electrical appliances to your projects. Equipments are based on Part shapes, which allow them to benefit from the solidity and possibilities of BRep geometry, and generate nice views when rendered to plan and section views.

Furniture objects enclosed in an Arch Equipment object. The flat projections can be obtained by the Draft Shape2DView tool

As of version 0.17, equipment objects also have a DataHiRes property where a Mesh object can be attached. Equipment objects can then be made to display that mesh in the 3D view instead of their shape, which allows to use any high-resolution mesh objects such as detailed pieces of furniture commonly found on websites.

Furniture objects enclosed in an Arch Equipment object, with a high resolution mesh attached

When using the Arch OBJ exporter, all equipment objects that are in mesh display mode will be exported as their mesh instead of their shape.

Usage

  1. Select a Part shape, and optionally a Mesh object.
  2. Press the Arch Equipment button, or press E then Q keys.

Options

  • Equipments share the common properties and behaviours of all Arch Components

Properties

  • DataModel: A description of the model of this equipment.
  • DataUrl: An URL of the product page where more information about this equipment can be found.
  • DataMesh: A Mesh representation to use for this equipment. When set, the Mesh display mode becomes available.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Equipment tool can be used in macros and from the Python console by using the following function:

Equipment = makeEquipment(baseobj=None, placement=None, name="Equipment")
  • Creates an Equipment object from the given baseobj, which can be a Part or a Mesh.
  • If a placement is given, it is used.
  • It returns None if the operation fails.

Example:

import FreeCAD, Arch

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 500
Box.Width = 2000
Box.Height = 600

Equip = Arch.makeEquipment(Box)
FreeCAD.ActiveDocument.recompute()